PROGRAM ACONVERT(INPUT,OUTPUT);
USES(AUDVID);
USES(MATH);
CONST PC=10;
    AR=11;
    XR=12;
    YR=13;
	PETSCII=143;	{SWITCH TO PETSCII}
	ISO=15;			{SWITCH TO ISO TEXT}
	CLS=147;		{CLEAR TEXT SCREEN}
    GXY=-16;
    GFX=-224;
    GCS=-221;
    GCL=-215;
    CIR=-203;
    RCT=-209;
    LIN=-212;
    SPX=-245;
    PXY=-257;
	SCR=-161;		{$FF5F KERNAL SCREEN MODE}
    STI=-37;
    RTI=-34;
	PCR=-191;		{$FF41 KERNAL GRAPH_PUT_CHAR}
	ABM=0;	{ABSOLUTE ADDRESSING}
	ZPX=1;	{ZERO PAGE X}
	ZPY=2;	{ZERO PAGE Y}
	INY=3;	{INDIRECT Y}
	INX=4;	{INDIRECT X}
	ABY=5;	{ABSOLUTE Y}
	ABX=6;	{ABSOLUTE X}
	IMM=7;	{IMMEDIATE}
	ZPP=8;	{ZERO PAGE}
	ACC=9;	{ACCUMULATOR}	
	IMP=10; {IMPLIED}
	BRA=11; {BRANCHES}
	BORDER=-24788;
	READST=$FFB7;		{$FFB7 KERNAL READ STATUS}
	OPEN=$FFC0;			{$FFC0 KERNAL OPEN}
	SETLFS=$FFBA;		{$FFBA KERNAL SET LOGICAL FILE}
	SETNAM=$FFBD;		{$FFBD KERNAL SET FILENAME}
	CHKIN=$FFC6;
	CHRIN=$FFCF;
	CHROUT=$FFD2;
	CHKOUT=$FFC9;
	CLALL=$FFE7;
VAR TI,X,A,B,Y,NUM,N,PGC,LN,COL,IDX,ORG,XE: INTEGER;
CVA: ARRAY[0..100] OF INTEGER;
CDO: ARRAY [0..100] OF INTEGER;
MODE:ARRAY [0..159] OF INTEGER;
CH,CH2: CHAR;
OPCODES: ARRAY [0..765] OF CHAR;
HEX: ARRAY [0..2] OF CHAR;
CHX: ARRAY[0..16] OF CHAR;
FILENAME: ARRAY [0..20] OF CHAR;
CFLAG,ABSOLUTE,AFLAG,ST: BOOLEAN;

PROCEDURE POKE(ADDR,VAL: INTEGER);
	BEGIN
		REGS[PC]:=1;		
		REGS[0]:=ADDR;
		REGS[AR]:=VAL;
		MEM();
	END;	
	
PROCEDURE SCRNMODE(MODE:INTEGER);
	BEGIN
		REGS[AR]:=MODE;
		CALL(SCR);
	END;
	
PROCEDURE GOTOXY(COL,ROW: INTEGER);
	BEGIN
		REGS[PC]:=0;
		REGS[YR]:=COL;
		REGS[XR]:=ROW;
		CALL(GXY);
	END;			
	
PROCEDURE ZTONINE(DIGIT: INTEGER);
VAR C: CHAR;
	BEGIN
		C:=CHR(DIGIT);
		DIGIT:=DIGIT-48;
		WRITE(C);
		IF N = 1 THEN NUM:=NUM*16+DIGIT ELSE NUM:=DIGIT;
		CFLAG:=TRUE;
	END;
	
PROCEDURE ATOF(DIGIT: INTEGER);
VAR C: CHAR;
	BEGIN
		C:=CHR(DIGIT);
		WRITE(C);	
		DIGIT:=DIGIT-65+10;
		IF N = 1 THEN NUM:=NUM*16+DIGIT ELSE NUM:=DIGIT;
		CFLAG:=TRUE;
	END;
	
PROCEDURE CATOF(DIGIT: INTEGER);
VAR C: CHAR;
	BEGIN
		C:=CHR(DIGIT);
		WRITE(C);
		DIGIT:=DIGIT-97+10;
		IF N = 1 THEN NUM:=NUM*16+DIGIT ELSE NUM:=DIGIT;
		CFLAG:=TRUE;
	END;
	
PROCEDURE OUTHEX(NUM: INTEGER);
VAR N: INTEGER;
CH: CHAR;
	BEGIN
		N:=NUM DIV 16;
		CH:=CHX[N+1];
		WRITE(CH);
		N:=NUM MOD 16;
		CH:=CHX[N+1];
		WRITE(CH);
	END;
	
FUNCTION INPUTHEX: INTEGER;
VAR CH: CHAR;
	I,Q: INTEGER;
	BEGIN
		N:=0;
		CFLAG:=FALSE;
		NUM:=0;
		WHILE N <= 1 DO BEGIN
			READ(CH);	
			HEX[N]:=CH;
			I:=ORD(CH);
			IF ORD(CH) >= 48 THEN BEGIN
				IF ORD(CH) <= 57 THEN ZTONINE(I);
			END;
			IF ORD(CH) >= 65 THEN BEGIN
				IF ORD(CH) <= 71 THEN ATOF(I);
			END;
			IF ORD(CH) >= 97 THEN BEGIN
				IF ORD(CH) <= 103 THEN CATOF(I);
			END;			
			IF CFLAG THEN BEGIN
				N:=N+1;
				CFLAG:=FALSE;
			END;
		END;
		INPUTHEX:=NUM;
	END;	
	

FUNCTION FILEOPEN(FILENUM: INTEGER; MODE: CHAR): BOOLEAN;
VAR X,FNL,FP,FNP,P,STATUS: INTEGER;
	FN: ARRAY[0..11] OF CHAR;
	BEGIN
		FNL:=FILENAME[0];
		IF FNL <= 20 THEN BEGIN
			X:=1;
			FNP:=PTR(FILENAME[1])*2;
			FP:=PTR(FN[0])*2;
			{CREATE A 'NORMAL' ZERO TERMINATED STRING}
			WHILE X <= FNL DO BEGIN
				P:=ORD(FILENAME[X]);
				POKE(FP+X-1,P);
				X:=X+1;
			END;
			POKE(FP+X-1,0);
		
			REGS[AR]:=FILENUM;
			REGS[XR]:=8;
			REGS[YR]:=FILENUM+1;	{secondary address, 2-15 for disk drives}
			CALL(SETLFS);
		
			REGS[AR]:=FNL;
			REGS[XR]:=FP MOD 256;
			REGS[YR]:=FP DIV 256;
			CALL(SETNAM);
		
			CALL(OPEN);
		
			REGS[XR]:=FILENUM;
			
			REGS[AR]:=8;
			CALL(READST);
			WRITELN('STATUS:',REGS[AR]);			
			
			IF ORD(MODE) = 'r' THEN CALL(CHKIN) ELSE BEGIN
				WRITELN('WRITING');
				CALL(CHKOUT);
			END;
			
			STATUS:=BITAND(REGS[AR],255);
		
			{ANY NON ZERO STATUS MEANS FILE WAS NOT OPENED SUCCESSFULLY}
			IF STATUS = 0 THEN FILEOPEN:=TRUE ELSE FILEOPEN:=FALSE;
		END;
		IF FNL > 20 THEN BEGIN
			WRITE('FILENAME TOO LONG');
			FILEOPEN:=FALSE;
		END;
	END;		
			
	
PROCEDURE INITOPS;
VAR X: INTEGER;
	BEGIN
		ST:=FILEOPEN(1,'r');
		X:=0;
		WHILE X < 765 DO BEGIN
			CALL(CHRIN);
			CH:=REGS[AR];
			IF CH > 32 THEN BEGIN
				OPCODES[X]:=CH;
				X:=X+1;
			END;
		END;
		CALL(CLALL);
	END;	
	
PROCEDURE ADDRESSING;
	BEGIN
		READ(MODE[0],'150,182');							{ZERO PAGE Y}	
		READ(MODE[2],'10,42,74,106');						{ACCUMULATOR}		
		READ(MODE[6],'17,49,81,113,145,177,209,241');		{INDEXED Y}
		READ(MODE[14],'1,33,65,97,129,161,193,225');		{INDEXED X}		
		READ(MODE[22],'25,57,89,121,153,185,190,217,249');	{ABSOLUTE Y}
		READ(MODE[31],'9,41,73,105,160,162,169,192,201,224,233');	{IMMEDIATE}		
															{ZERO PAGE X}
		READ(MODE[42],'21,22,53,54,85,86,116,117,118,148,149,180,181,213,214,245');	
		READ(MODE[58],'246');	
															{ABSOLUTE}		
		READ(MODE[59],'13,14,32,44,45,46,76,77,78,109,110,140,141,142,156,172');
		READ(MODE[75],'173,174,204,205,206,236,237,238');
															{ABSOLUTE X}
		READ(MODE[83],'29,30,61,62,93,94,125,126,157,158,188,189,221,222,253,254');
															{ZERO PAGE}
		READ(MODE[99],'5,6,36,37,38,69,70,100,101,102,132,133,134,164,165,166,196');
		READ(MODE[116],'197,198,228,229,230'); 
															{BRANCH}
		READ(MODE[121],'16,48,80,112,128,144,176,208,240');
															{IMPLIED}
		READ(MODE[130],'0,8,24,40,50,64,72,88,90,96,104,120,122,136,138');
		READ(MODE[145],'152,154,168,170,184,186,200,202,216,218');
		READ(MODE[155],'232,234,248,250');
		{READ(MODES[0],'ABMZPXZPYINYINXABYABXIMMZPPACCIMP');}
	END;
	
PROCEDURE CODESTRING(POS: INTEGER);
VAR N,I: INTEGER;
	BEGIN
		POS:=POS*3;
		N:=POS;
		GOTOXY(38,LN);
		FOR I:=0 TO 2 DO BEGIN
			WRITE(OPCODES[N]);
			N:=N+1;
		END;
	END;	
	
PROCEDURE DOORG;	{CONVERT ORIGIN ADDRESS TO HEXADECIMAL}
VAR N: INTEGER;
	BEGIN
		GOTOXY(30,LN);
		WRITE('$');
		N:=ORG DIV 256;
		OUTHEX(N);
		N:=ORG MOD 256;
		OUTHEX(N);
	END;
	
PROCEDURE AMODE(M: INTEGER);
VAR ARG,N: INTEGER;
	BEGIN
		DOORG;
		ARG:=CDO[X];		
		CODESTRING(ARG);	{WRITE OPCODE MNEMONIC}
		X:=X+1;				{ADVANCE X TO GET ARGUMENT}
		ORG:=ORG+1;
		IF M = ZPY THEN BEGIN
			ARG:=CDO[X];
			OUTHEX(ARG);
			WRITE(',Y');
			AFLAG:=TRUE;
		END;

		IF M = ZPX THEN BEGIN
			ARG:=CDO[X];
			OUTHEX(ARG);
			WRITE(',X');
			AFLAG:=TRUE;
		END;

		IF M = INX THEN BEGIN
			WRITE(' (');
			ARG:=CDO[X];
			OUTHEX(ARG);
			WRITE(',X)');
			AFLAG:=TRUE;
		END;

		IF M = INY THEN BEGIN
			WRITE(' ($');
			ARG:=CDO[X];
			OUTHEX(ARG);
			WRITE('),Y');
			AFLAG:=TRUE;
		END;

		IF M = ACC THEN BEGIN
			WRITE(' A');
			X:=X-1;
			AFLAG:=TRUE;
		END;

		IF M = ABM THEN BEGIN
			WRITE(' $');
			ARG:=CDO[X+1];
			OUTHEX(ARG);
			X:=X+1;
			ORG:=ORG+1;
			ARG:=CDO[X-1];
			OUTHEX(ARG);
			AFLAG:=TRUE;
		END;

		IF M = ABY THEN BEGIN
			WRITE(' $');
			ARG:=CDO[X+1];
			OUTHEX(ARG);
			X:=X+1;
			ORG:=ORG+1;			
			ARG:=CDO[X-1];
			OUTHEX(ARG);
			WRITE(',Y');
			AFLAG:=TRUE;
		END;

		IF M = ABX THEN BEGIN
			WRITE(' $');
			ARG:=CDO[X+1];
			OUTHEX(ARG);
			X:=X+1;
			ORG:=ORG+1;			
			ARG:=CDO[X-2];
			OUTHEX(ARG);
			WRITE(',X');
			AFLAG:=TRUE;
		END;

		IF M = ZPP THEN BEGIN
			WRITE(' $');
			ARG:=CDO[X];
			OUTHEX(ARG);
		END;

		IF M = IMM THEN BEGIN
			WRITE(' #$');
			ARG:=CDO[X];
			OUTHEX(ARG);
			AFLAG:=TRUE;
		END;
		
		IF M = IMP THEN BEGIN
			X:=X-1;
		END;
		
		IF M = BRA THEN BEGIN	{DOES NOT TAKE PAGE BOUNDARIES INTO ACCOUNT}
			WRITE(' $');
			IF CDO[X] > 127 THEN BEGIN
				ARG:=256-CDO[X];
				ARG:=ORG-(ARG);
			END;
			IF CDO[X] <= 127 THEN ARG:=ORG+CDO[X]+2;
			N:=ARG DIV 256;
			OUTHEX(N);
			N:=ARG MOD 256;
			OUTHEX(N);
		END;
		
		X:=X+1;
		ORG:=ORG+1;
	END;

PROCEDURE GETMODE(OC: INTEGER);
VAR I,J,OM: INTEGER;
	BEGIN
		I:=0;
		WHILE I <= 158 DO BEGIN
			J:=MODE[I];
			IF OC = J THEN BEGIN
				OM:=I;
			END;
			I:=I+1;
		END;
			IF OM < 2 THEN AMODE(ZPY) ELSE
				IF OM < 6 THEN AMODE(ACC) ELSE
					IF OM < 14 THEN AMODE(INY) ELSE
						IF OM < 22 THEN AMODE(INX) ELSE
							IF OM < 31 THEN AMODE(ABY) ELSE
								IF OM < 42 THEN AMODE(IMM) ELSE
									IF OM < 59 THEN AMODE(ZPX) ELSE
										IF OM < 83 THEN AMODE(ABM) ELSE
											IF OM < 99 THEN AMODE(ABX);
			IF AFLAG = FALSE THEN BEGIN
				IF OM < 121  THEN AMODE(ZPP) ELSE
					IF OM < 130 THEN AMODE(BRA) ELSE AMODE(IMP);
			END;
		AFLAG:=FALSE;
	END;	
	    
BEGIN
	READ(FILENAME[0],'OPCODES.DAT');
	INITOPS;
	ADDRESSING;
	READ(CHX[0],'0123456789ABCDEF');
	SCRNMODE(0);
	CH2:=CHR(147);				{CLEAR TEXT SCREEN}
	{POKE(BORDER,5);}
	WRITE(CH2);
	CH:=CHR(158);					{YELLOW TEXT}
	WRITE(CH);
	PGC:=0;
	LN:=3;
	COL:=5;
	B:=0;
	IDX:=0;
	AFLAG:=FALSE;
	WHILE B <=  255 DO BEGIN
		GOTOXY(0,59);
		WRITE('ACONVERT - A PROGRAM TO CONVERT MACHINE CODE BYTES TO INTEGERS');
		GOTOXY(0,0);
		WRITE('ENTER A HEX VALUE, GG TO STOP:                      ');
		GOTOXY(30,0);
		B:=INPUTHEX;
		GOTOXY(COL,LN);
		IF ODD(PGC) = FALSE THEN BEGIN
			WRITE(HEX[0],HEX[1]);
			{OUTHEX(B);}
			COL:=10;
			IF B > 255 THEN CDO[PGC]:=0 ELSE CDO[PGC]:=B;
		END;
		IF ODD(PGC) = TRUE THEN BEGIN
			WRITE(HEX[0],HEX[1]);
			{OUTHEX(B);}
			COL:=5;
			IF B > 255 THEN CDO[PGC]:=0 ELSE CDO[PGC]:=B;
			CVA[IDX]:=CDO[PGC-1]+CDO[PGC]*256;
			LN:=LN+1;
			IDX:=IDX+1;
		END;
		PGC:=PGC+1;
	END;
	ORG:=4096;
	X:=0;
	XE:=(IDX*2);
	LN:=3;
	WHILE X < XE DO BEGIN
		Y:=CDO[X];
		GETMODE(Y);
		LN:=LN+1;
	END;
	GOTOXY(0,0);
	WRITE('PRESS A KEY TO SHOW CODE ARRAY  ');
	READ(TI);
	WRITE(CH2);
	X:=1;
	Y:=0;
	CH:=CHR(39);
	LN:=0;
	GOTOXY(0,LN);
	LN:=LN+1;
	WRITELN('CODE ARRAY SHOULD BE:');
	WRITE('READ(CODE[',0,'],',CH);
	WRITE(CVA[0]);
	WHILE X < IDX DO BEGIN
		IF X MOD 7 <> 0 THEN WRITE (',',CVA[X]) ELSE BEGIN
			WRITE(CH,');');
			LN:=LN+1;
			GOTOXY(0,LN);
			WRITE('READ(CODE[',X+1,'],',CH);
			WRITE(CVA[X]);
		END;
		X:=X+1;
	END;
	WRITELN(CH,');');
	GOTOXY(0,0);
	WRITE('PRESS ENTER TO WRITE FILE CODE.TXT');
	READ(TI);
	READ(FILENAME[0],'@0:CODE2.TXT,S,W');
	ST:=FILEOPEN(1,'w');
	WRITE('READ(CODE[',0,'],',CH);
	WRITE(CVA[0]);
	X:=1;
	WHILE X < IDX DO BEGIN
		IF X MOD 7 <> 0 THEN WRITE(',',CVA[X]) ELSE BEGIN
			WRITELN(CH,');');
			WRITE('READ(CODE[',X,'],',CH);
			WRITE(CVA[X]);
		END;
		X:=X+1;
	END;
	WRITELN(CH,');');
	CALL(CLALL);
	READ(TI);
 END.
