PROGRAM AUTOMATA(INPUT,OUTPUT);
USES(MATH);
USES(AUDVID);
CONST
	DUMMY = 0;
	PC=10;		{RESERVED FOR CARRY FLAG IN REGS[]}
    AR=11;		{RESERVED FOR .A REGISTER IN REGS[]}
    XR=12;		{RESERVED FOR .X REGISTER IN REGS[]}
    YR=13;		{RESERVED FOR .Y REGISTER IN REGS[]}
    GFX=-224;	{$ff20 kernal graph init}
    GCS=-221;	{$ff23 kernal graph clear}
    GCL=-215;	{$ff29 kernal graph set colors}
    RCT=-209;	{$ff2f kernal graph draw rectangle}
    LIN=-212;	{$ff2c kernal graph draw line}
    SPX=-245;	{$ff0b kernal FB_set_pixel}
    GPX=-251;	{$ff05 kernal FB_get_picel}
    PXY=-257;	{$ffef kernal FB_cursor_position}
    STI=-37;	{$ffdb kernal SETTIM}
    RTI=-34;	{$ffde kernal RDTIM}
	CLS=147;	{clear text screen}
	GXY=-16;    {$fff0 kernal PLOT}
	MOUSE=$FF68;	{KERNAL MOUSE CONFIG}
	MS_GET=$FF6B;	{KERNAL MOUSE GET}
	SP_POS=$FEF3;	{KERNAL SPRITE SET POSITION}	
    BLACK=0;
    RED=2;
    GREEN=5;
    BLUE=6;
VAR I,SEED,Q,D,POS,SEC,JIF,CDP,NRP,A,B,C,P: INTEGER;
ROW,NROW: ARRAY [0..200] OF INTEGER;
CODE:ARRAY [0..10] OF INTEGER;
COLORS:ARRAY [0..3] OF INTEGER;
DECODE:ARRAY [0..7] OF INTEGER;
FAVEC:ARRAY [0..110] OF INTEGER;
FAVES:ARRAY [0..11] OF INTEGER;
CD: ARRAY [0..23] OF INTEGER;
CMD:CHAR;
M:BOOLEAN;

PROCEDURE PAUSE(JIFFIES: INTEGER);
	BEGIN
		REGS[AR]:=JIFFIES;
		WAIT();
	END;

PROCEDURE FMNOTE(CHANNEL,NOTE: INTEGER);
VAR ADDR: INTEGER;
	BEGIN
		ADDR:=-16381;		{can't load this directly!}
		REGS[0]:=ADDR;		{$C003 BASIC FMNOTE LO BYTE}
		REGS[AR]:=CHANNEL;
		REGS[XR]:=NOTE;
		REGS[PC]:=0;		{CARRY MUST BE CLEAR}
		AUDIO();			{ACCESS BASIC AUDIO ROUTINE}
	END;

PROCEDURE INSTRUMENT(CHANNEL,PATCH: INTEGER);
VAR ADDR: INTEGER;
	BEGIN
		ADDR:=-16279;		
		REGS[0]:=ADDR;		{$C069 LOAD PATCH(INSTRUMENT)}
		REGS[AR]:=CHANNEL;
		REGS[XR]:=PATCH;
		REGS[PC]:=1;		{CARRY MUST BE SET}
		AUDIO();			{ACCESS BASIC AUDIO ROUTINE}
	END;

PROCEDURE SETTIME(H,M,S:INTEGER);	{set software clock}
    BEGIN
        REGS[AR]:=H;REGS[XR]:=M;
        REGS[YR]:=S;
        CALL(STI);
    END;

PROCEDURE GRAPHICS;					{turn on grahics mode}
    BEGIN
        REGS[0]:=0;
        CALL(GFX);
    END;

PROCEDURE GCLEAR;					{clear graphics screen}
    BEGIN
        CALL(GCS);
    END;
	
PROCEDURE GOTOXY(COL,ROW: INTEGER);
	BEGIN
		REGS[PC]:=0;
		REGS[YR]:=COL;
		REGS[XR]:=ROW;
		CALL(GXY);
	END;

PROCEDURE PIXELXY(X,Y: INTEGER);	{locate pixel cursor}
    BEGIN
        REGS[0]:=X;
        REGS[1]:=Y;
        CALL(PXY);
    END;

PROCEDURE SETPIXEL(C: INTEGER);		{set pixel value(color) from nrow[c]}
    BEGIN
        REGS[AR]:=NROW[C];
        CALL(SPX);	
    END;
	
FUNCTION GETPIXEL:INTEGER;			{get pixel value(color)}
    BEGIN
        CALL(GPX);
        GETPIXEL:=REGS[AR];
    END;	

PROCEDURE GCOLORS(FG,BG,FILL: INTEGER);	{set frame buffer colors}
    BEGIN
        REGS[AR]:=FG;
        REGS[YR]:=BG;
        REGS[XR]:=FILL;
        CALL(GCL);
    END;
	
PROCEDURE MOUSE_ON;
	BEGIN
		REGS[AR]:=1;
		REGS[XR]:=0;
		REGS[YR]:=0;
		CALL(MOUSE);
	END;	

PROCEDURE RECT(X,Y,W,H,FILL: INTEGER);	{draw rectangle}
    BEGIN
        REGS[PC]:=FILL;
        REGS[0]:=X;REGS[1]:=Y;REGS[2]:=W;REGS[3]:=H;REGS[4]:=0;
        CALL(RCT);
    END;
	
PROCEDURE GETROW(H,I:INTEGER);			{fill nrow array from screen}
    VAR D,E,N:INTEGER;
    BEGIN
        N:=0;
        D:=H;
        E:=I;
        PIXELXY(H,I);
        WHILE N<200 DO BEGIN
            NROW[N]:=GETPIXEL;	{GETPX(0);}
            N:=N+1;
        END;
    END;	

PROCEDURE PUTROW(X,Y:INTEGER);			{set screen row from nrow array}
    VAR X2,Y2,N:INTEGER;
    BEGIN
		N:=Y*320+X;		{CALC BITMAP LOCATION}
		REGS[1]:=N;		{PLACE IN $04/$05}
		REGS[0]:=NRP;	{LOAD ADDRESS OF NROW IN $02/$03}	
		SYS(CDP);		{CALL M/L ROUTINE TO PLOT NROW TO BITMAP SCREEN}
    END;    

PROCEDURE NEXTROW;				{calculate next 'generation'}
VAR AL,AC,AR,N,CL:INTEGER;
    BEGIN
        AL:=0;
        AC:=DECODE[NROW[0]];
        AR:=DECODE[NROW[1]];
        NROW[0]:=COLORS[CODE[AL+AC+AR]];
        N:=2;
		REPEAT
            AL:=AC;
            AC:=AR;
            AR:=DECODE[NROW[N]];
            NROW[N-1]:=COLORS[CODE[AL+AC+AR]];
            N:=N+1;
		UNTIL N = 200;
        AL:=AC;
        AC:=DECODE[NROW[199]];
        AR:=0;
        NROW[199]:=COLORS[CODE[AL+AC+AR]];
    END;

PROCEDURE DOROWS;			{plot all rows}
VAR A: INTEGER;
    BEGIN
        A:=50;
        PUTROW(60,A);
        REPEAT
            NEXTROW;
            PUTROW(60,A+1);
			PIXELXY(262,A);
			SETPIXEL(200);
            A:=A+1;
        UNTIL A = 201
    END;

PROCEDURE DOBITS(S:INTEGER);
VAR N: INTEGER;
	BEGIN
		N:= BITAND(S,128);
		IF N = 128 THEN NROW[POS+7]:=COLORS[2];	
		N:= BITAND(S,64);
		IF N = 64 THEN NROW[POS+6]:=COLORS[2];	
		N:= BITAND(S,32);		
		IF N = 32 THEN NROW[POS+5]:=COLORS[2];
		N:= BITAND(S,16);		
		IF N = 16 THEN NROW[POS+4]:=COLORS[2];	
		N:= BITAND(S,8);		
		IF N = 8 THEN NROW[POS+3]:=COLORS[2];	
		N:= BITAND(S,4);		
		IF N = 4 THEN NROW[POS+2]:=COLORS[2];	
		N:= BITAND(S,2);		
		IF N = 2 THEN NROW[POS+1]:=COLORS[2];	
		N:= BITAND(S,1);		
		IF N = 1 THEN NROW[POS+0]:=COLORS[2];	
	END;

PROCEDURE PLOT(S:INTEGER);		{setup and do plot}
VAR TMP,B:INTEGER;
	BEGIN
		B:=0;
		IF SEED <> 0 THEN BEGIN
			WHILE B < 200 DO BEGIN
				NROW[B]:=COLORS[0];
				B:=B+1;
			END;
		END;
		DOBITS(SEED);
	    DOROWS;
	END;
	
FUNCTION READTIME: INTEGER;		{read software clock}
VAR T1:INTEGER;
    BEGIN
        CALL(RTI);
		T1:=(REGS[XR]*256) + REGS[AR];
        READTIME:= T1;     
    END;	
	
PROCEDURE SPACE(N: INTEGER);	{write 'n' spaces to text screen}
VAR Q: INTEGER;
	BEGIN
		Q:=0;
		WHILE Q <= N DO BEGIN
			WRITE(' ');
			Q:=Q+1;
		END;
	END;
	
FUNCTION GETCH:CHAR;			{get a number between 0 and 3}
VAR CH:CHAR;
	BEGIN
		CH:='4';
		WHILE ORD(CH) > '3' DO READ(CH);
		GETCH:=CH;
	END;
		

PROCEDURE GETCODE;				{get a 10 digit 'code'}
VAR A: INTEGER;
CODESTR: ARRAY[0..10] OF CHAR;
L:CHAR;
    BEGIN
        A:=0;
        GOTOXY(0,2);
        WRITELN('Enter 10 digit code of 0-3 each: ');
		L:=' ';
		GOTOXY(5+A,27);
		SPACE(10);
		GOTOXY(5+A,27);
		WHILE A < 10 DO BEGIN
			L:=GETCH;		
			WRITE(L);
			CODE[A]:=ORD(L)-48;
			A:=A+1;
		END;
		GOTOXY(0,2);
		SPACE(33);
    END;
	
PROCEDURE GETSEED;				{get a 'seed' value (0-255)}
	BEGIN
        GOTOXY(0,2);
        WRITELN('Enter seed value (1-255): ');
		GOTOXY(23,27);
		READ(SEED);
		IF SEED < 0 THEN SEED:=0;
		IF SEED > 255 THEN SEED:=255;
		GOTOXY(23,27);
		WRITE(SEED,'    ');
        GOTOXY(0,2);
		SPACE(24);
        WRITELN;
	END;
	
PROCEDURE GETPOS;				{get a position to put 'seed' bits}
	BEGIN
        GOTOXY(0,2);
        WRITELN('Enter position value (0-192): ');
		GOTOXY(35,27);
		READ(POS);
		IF POS > 192 THEN POS:=192;
		IF POS < 0 THEN POS:=0;
		GOTOXY(35,27);
		WRITE(POS,'    ');
        GOTOXY(0,2);
		SPACE(28);
        WRITELN;
	END;

PROCEDURE INIT;					{initiailize stuff}
VAR D: INTEGER;
    BEGIN
		NROW[200]:=1;
        COLORS[0]:=BLACK;
        COLORS[1]:=RED;
        COLORS[2]:=GREEN;
        COLORS[3]:=BLUE;
        READ(DECODE[0],'0,0,1,1,1,2,3');
        SEED:=0;
		POS:=96;
		D:=0;
		WHILE D < 200 DO BEGIN
			NROW[D]:=COLORS[RAND(3)];
			D:=D+1;
		END;		
        READ(CODE[0],'1,0,1,1,3,0,3,0,0,3');
        GRAPHICS;
        GCOLORS(0,0,0); 
        CALL(GCS);
        GCOLORS(7,0,0);
        RECT(59,49,202,154,0);      
        GOTOXY(0,0);
        WRITELN('4 State Linear, Cellular Automata');
        GOTOXY(0,27);
        WRITELN('Code:');
        Q:=0;
        WHILE Q < 10 DO BEGIN
            GOTOXY(Q+5,27);
            WRITE(CODE[Q]);
            Q:=Q+1;
        END;
        GOTOXY(18,27);
        WRITE('Seed:Random');
		GOTOXY(31,27);
		WRITE('Pos:',POS);
		INSTRUMENT(1,156);		{CHANNEL 1, OPEN TRIANGLE}
		READ(CD[0],'169,9613,-23137,-29436,-24800,1445,8589,-22113,-29424');
		READ(CD[9],'-24798,160,689,9101,6303,677,361,645,933,105,901');
		READ(CD[20],'-16184,-12088,24809');
		CDP:=PTR(CD[0]);		{POINTER TO CD[] - CODE ARRAY}
		NRP:=PTR(NROW[0])*2;	{POINTER TO NROW}			
    END;

PROCEDURE SETFAVE;			{setup favorites code and seed arrays}
	BEGIN
        READ(FAVEC[0],'2,2,2,1,1,3,0,3,0,3');
		READ(FAVEC[10],'1,2,3,3,2,3,3,3,2,0');
        READ(FAVEC[20],'0,1,1,0,3,1,0,3,0,1');
        READ(FAVEC[30],'1,2,3,1,2,3,3,3,3,0');
		READ(FAVEC[40],'3,2,2,0,0,0,0,3,0,1');
        READ(FAVEC[50],'0,3,1,3,2,2,1,3,3,0');
		READ(FAVEC[60],'3,2,0,0,1,1,0,0,1,2');
        READ(FAVEC[70],'0,3,3,3,2,3,1,1,0,1');
        READ(FAVEC[80],'3,1,1,3,2,0,2,0,0,3');
		READ(FAVEC[90],'2,2,3,2,3,3,1,0,2,0');
		READ(FAVEC[100],'3,3,0,0,3,0,2,3,3,1');
		READ(FAVES[0],'237,237,24,237,33,103,60,124,189,44,129');
	END;
	
PROCEDURE BELL;
	BEGIN
		FMNOTE(1,91);
		PAUSE(30);
		FMNOTE(1,0);
	END;	

BEGIN						{start of main procedure}		
		SETFAVE;
        INIT;
		SETTIME(0,0,0);
		PLOT(SEED);
		I:=READTIME;		
		GOTOXY(0,2);
		BELL;
		SEC:=I DIV 60;
		JIF:=I MOD 60;		
		WRITE(SEC,' Seconds ',JIF,' Jiffies');	
        WHILE CMD <> 'q' DO BEGIN				{main loop}
            GOTOXY(0,1);
            WRITELN('Enter Command (C,S,P,D,R,M,H,Z,F,Q): ');
            READ(CMD);
			GOTOXY(36,1);
			WRITE(CMD);
            IF ORD(CMD) = 'd' THEN BEGIN
                GCLEAR;
                RECT(59,49,202,154,0);
                PLOT(SEED);
				BELL;
            END;
            IF ORD(CMD) = 'c' THEN GETCODE;
			IF ORD(CMD) = 's' THEN GETSEED;
			IF ORD(CMD) = 'p' THEN GETPOS;
            IF ORD(CMD) = 'r' THEN BEGIN
                GOTOXY(18,27);
                WRITE('Seed:Random');  
				D:=0;
				WHILE D < 200 DO BEGIN
					SEED:=0;
					NROW[D]:=COLORS[RAND(3)];
					D:=D+1;
				END;
            END;
			IF ORD(CMD) = 'm' THEN BEGIN
				GETROW(60,200);
				GCLEAR;
				RECT(59,49,202,154,0);
				DOROWS;
			END;
			IF ORD(CMD) = 'h' THEN BEGIN
				GOTOXY(0,2);
				WRITELN('C=Chg Code S=Chg Seed Z=Rnd Code D=Draw');
				WRITELN('R=Rnd Seed M=More H=Help P=Chg Pos');
				WRITE('F=Favorites, Q=Quit');
				READ(CMD);
				GOTOXY(34,1);
				WRITE(' ');				
				GOTOXY(0,2);
				SPACE(43);
				WRITELN;
				SPACE(44);
				WRITELN;
				SPACE(44);
			END;
			IF ORD(CMD) = 'z'THEN BEGIN
				D:=0;
				WHILE D < 10 DO BEGIN
					CODE[D]:=RAND(4);
					D:=D+1;					
				END;
				Q:=0;
				WHILE Q < 10 DO BEGIN
					GOTOXY(Q+5,27);
					WRITE(CODE[Q]);
					Q:=Q+1;
				END;
			END;
			IF ORD(CMD) = 'f' THEN BEGIN
				D:=0;
				I:=0;
				WHILE I < 11 DO BEGIN
					CODE[0]:=FAVEC[D+0];
					CODE[1]:=FAVEC[D+1];
					CODE[2]:=FAVEC[D+2];
					CODE[3]:=FAVEC[D+3];
					CODE[4]:=FAVEC[D+4];
					CODE[5]:=FAVEC[D+5];
					CODE[6]:=FAVEC[D+6];
					CODE[7]:=FAVEC[D+7];
					CODE[8]:=FAVEC[D+8];
					CODE[9]:=FAVEC[D+9];
					SEED:=FAVES[0+D DIV 10];
					Q:=0;
					WHILE Q < 10 DO BEGIN
						GOTOXY(Q+5,27);
						WRITE(CODE[Q]);
						Q:=Q+1;
					END;
					GOTOXY(23,27);
					WRITE(SEED,'    ');
					GCLEAR;
					RECT(59,49,202,154,0);
					PLOT(SEED);
					BELL;
					D:=D+10;
					I:=I+1;
					Q:=0;
					PAUSE(180);
				END;
			END;
			GOTOXY(34,1);
			WRITE(' ');
        END;
 END.
