{VPOKE DEMO PROGRAM}
PROGRAM BALLS(INPUT,OUTPUT);
USES(AUDVID);
USES(MATH);
CONST
	DUMMY = 0;
	PC=10;			{RESERVED FOR CARRY FLAG IN REGS[]}
    AR=11;			{RESERVED FOR .A REGISTER IN REGS[]}
    XR=12;			{RESERVED FOR .X REGISTER IN REGS[]}
    YR=13;			{RESERVED FOR .Y REGISTER IN REGS[]}
	PETSCII=143;	{SWITCH TO PETSCII}
	ISO=15;			{SWITCH TO ISO TEXT}
	CLS=147;		{CLEAR TEXT SCREEN}
    PLT=-16;
    GFX=-224;
    GCS=-221;
    GCL=-215;
    CIR=-203;
    RCT=-209;
    LIN=-212;
    SPX=-245;
    PXY=-257;
	SCR=-161;		{$FF5F KERNAL SCREEN MODE}
    STI=-37;
    RTI=-34;
	PCR=-191;		{$FF41 KERNAL GRAPH_PUT_CHAR}
	GXY=-16;    {$fff0 kernal PLOT}	
	SCREEN=-20480;	{$B000 VRAM ADDRESS OF TEXT SCREEN}
VAR A,M,O,P,Q,S: INTEGER;
BX: ARRAY [0..255] OF INTEGER;
BY: ARRAY [0..255] OF INTEGER;
BC: ARRAY [0..255] OF INTEGER;
DX: ARRAY [0..255] OF INTEGER;
DY: ARRAY [0..255] OF INTEGER;
TXTCOL: ARRAY [0..15] OF INTEGER;
CH,CH2: CHAR;
STR,STR2: ARRAY [0..30] OF CHAR;

PROCEDURE PAUSE(JIFFIES: INTEGER);
	BEGIN
		REGS[AR]:=JIFFIES;
		WAIT();
	END;

PROCEDURE FMDRUM(CHANNEL,DRM: INTEGER);
VAR ADDR: INTEGER;
	BEGIN
		ADDR:=-16273;		{can't load this directly!}
		REGS[0]:=ADDR;		{$C06F BASIC FMNOTE LO BYTE}
		REGS[AR]:=CHANNEL;
		REGS[XR]:=DRM;
		REGS[PC]:=0;		{CARRY MUST BE CLEAR}
		AUDIO();			{ACCESS BASIC AUDIO ROUTINE}
	END;

PROCEDURE VPOKE(BANK,ADDR,VAL: INTEGER);
	BEGIN
		REGS[PC]:=1;
		REGS[AR]:=BANK;
		REGS[0]:=ADDR;
		REGS[YR]:=VAL;
		VMEM();
	END;	
	
FUNCTION VPEEK(BANK,ADDR: INTEGER): INTEGER;
	BEGIN
		REGS[PC]:=0;
		REGS[AR]:=BANK;
		REGS[0]:=ADDR;
		VMEM();
		VPEEK:=REGS[AR];
	END;
	
PROCEDURE SCRNMODE(MODE:INTEGER);
	BEGIN
		REGS[AR]:=MODE;
		CALL(SCR);
	END;
	
PROCEDURE GOTOXY(COL,ROW: INTEGER);
	BEGIN
		REGS[PC]:=0;
		REGS[YR]:=COL;
		REGS[XR]:=ROW;
		CALL(GXY);
	END;
	
PROCEDURE GCOLORS(FG,BG,FILL: INTEGER);
    BEGIN
        REGS[AR]:=FG;
        REGS[YR]:=BG;
        REGS[XR]:=FILL;
        CALL(GCL);
    END;

PROCEDURE PLOT(COLUMN,ROW: INTEGER);
    BEGIN
        REGS[PC]:=0;
        REGS[XR]:=ROW;
        REGS[YR]:=COLUMN;
        CALL(PLT);
    END;

PROCEDURE BELL;
	BEGIN
		CH:=CHR(7);		{PETSCII BELL SOUND}
		WRITE(CH);	
	END;
	
PROCEDURE DXZERO;
	BEGIN
		IF BX[O] <> 0 THEN BX[O]:=BX[O]-1 ELSE BEGIN
			DX[O]:= 1;
			FMDRUM(3,32);
		END;
	END;
	
PROCEDURE DXONE;
	BEGIN
		IF BX[O] <> 39 THEN BX[O]:=BX[O]+1 ELSE BEGIN
			BX[O]:=38;
			DX[O]:=0;
			FMDRUM(2,47)
		END;
	END;

PROCEDURE DYZERO;
	BEGIN
		IF BY[O] <> 0 THEN BY[O]:=BY[O]-1 ELSE BEGIN
			DY[O]:= 1;
			FMDRUM(3,32)
		END;
	END;

PROCEDURE DYONE;
	BEGIN
		IF BY[O] <> 29 THEN BY[O]:=BY[O]+1 ELSE BEGIN
			BY[O]:=28;
			DY[O]:=0;
			FMDRUM(2,47)
		END;
	END;	
     
BEGIN
	WRITE('How many balls (1-30)');
	M:=31;
	WHILE M > 30 DO BEGIN
		READ(M);
		IF M = 0 THEN M:=11;
		GOTOXY(21,0);
		WRITE('   ');
		GOTOXY(21,0);
	END;
	SCRNMODE(3);
	CH:=CHR(PETSCII);
	WRITE(CH);
	CH:=CHR(CLS);				{CLEAR TEXT SCREEN}
	WRITE(CH);
	A:=0;
	FMDRUM(2,25);
	REPEAT
		VPOKE(1,SCREEN+A,81);	
		A:=A+2;
	UNTIL A >= 7504;	
	FMDRUM(2,49);
	PAUSE(60);
	O:=0;
	WHILE O <= M DO BEGIN
		BX[O]:=RAND(40);
		BY[O]:=RAND(30);
		BC[O]:=RAND(10)+1;
		DX[O]:=RAND(2);
		DY[O]:=RAND(2);
		O:=O+1;
	END;
	Q:=0;
	WHILE Q = 0 DO BEGIN
		O:=0;
		REPEAT
			P:=BY[O]*256+BX[O]*2+1;		{IS BX[O]+BX[O] FASTER THAN BX[O]*2 ?}
			VPOKE(1,SCREEN+P,0);
			IF DX[O] = 0 THEN DXZERO;
			IF DX[O] = 1 THEN DXONE;
			IF DY[O] = 0 THEN DYZERO;
			IF DY[O] = 1 THEN DYONE;			
			P:=BY[O]*256+BX[O]*2+1;		{NO! *2 IS 10% FASTER THAN ADDITION}
			CH:=BC[O];
			VPOKE(1,SCREEN+P,CH);		{ARRAY VALUE HERE CRASHES!}
			O:=O+1;
		UNTIL O = M;
	END;
 END.
