PROGRAM FLOATS(INPUT,OUTPUT); 
USES(MATH);
CONST
	DUMMY=0;
	PC=10;			{CPU Carry flag}
    AR=11;			{Accumulator = REGS[AR]}
    XR=12;			{X Register = REGS[XR]}
    YR=13;			{Y register = REGS[AY]}
	PETSCII=143;	{SWITCH TO PETSCII}
	ISO=15;			{SWITCH TO ISO TEXT}
	CLS=147;		{CLEAR TEXT SCREEN}
	SCR=$FF5F;		{KERNAL SCREEN MODE}	
    GXY=$FFF0;		{Kernal PLOT}
    GFX=$FF20;		{Kernal GRAPH_INIT}	
	MOUSE=$FF68;	{KERNAL MOUSE CONFIG}
	MS_GET=$FF6B;	{KERNAL MOUSE GET}
	SP_POS=$FEF3;	{KERNAL SPRITE SET POSITION}
	GIVAYF=$FE03;	{CONVERT SIGNED INTEGER TO FLOAT}
	MOVMF=$FE66;	{MOVE FLOAT FAC TO MEMORY}
	MOVFM=$FE63;	{MOVE FLOAT MEMORY TO FAC}
	CONUPK=$FE5A;	{MOVE FLOAT MEMORY TO FAC2(ARG)}
	FDIVT=$FE27;	{FAC = ARG/FAC}
	FOUT=$FE06;		{CONVERT FLOAT FAC TO STRING @ $0100}
	NEGOP=$FE33;	{FLIP SIGN OF VALUE IN FAC}
	VAL1=$FE09;		{CONVERT ASCII STRING TO FP}
	BORDER=$9F2C;	{VERA Border Color}
TYPE STRNG = ARRAY [0..30] OF CHAR;
TYPE FLOAT = ARRAY [0..2] OF INTEGER;
VAR TI,MX,MY,MB,PRSTRG,SP,J,K,Y,C,BPTR,FS: INTEGER;
ADDF,SUBF,MULF,DIVF,IT2F: INTEGER;	{POINTERS TO M/L CODE}
FP,FP2,FPR: INTEGER;				{POINTERS TO FLOATS}
CODE: ARRAY [0..100] OF INTEGER;		{MEMORY FOR CODE}
CH,CH2,L: CHAR;
MYSTR,FPSTR: STRNG;
MYFLT,FLT2,RES,FPZERO,FPONE: FLOAT;	
	
PROCEDURE POKE(ADDR,VAL: INTEGER);
	BEGIN
		REGS[PC]:=1;		
		REGS[0]:=ADDR;
		REGS[AR]:=VAL;
		MEM();
	END;	
	
FUNCTION PEEK(ADDR: INTEGER): INTEGER;
	BEGIN
		REGS[PC]:=0;		
		REGS[0]:=ADDR;
		MEM();
		PEEK:=REGS[AR];
	END;	
	
PROCEDURE SCRNMODE(MODE:INTEGER);
	BEGIN
		REGS[AR]:=MODE;
		CALL(SCR);
	END;
				
PROCEDURE GOTOXY(COL,ROW: INTEGER);
	BEGIN
		REGS[PC]:=0;
		REGS[YR]:=COL;
		REGS[XR]:=ROW;
		CALL(GXY);
	END;				
	
PROCEDURE MOUSE_ON;
	BEGIN
		REGS[AR]:=1;
		REGS[XR]:=320 DIV 8;
		REGS[YR]:=240 DIV 8;
		CALL(MOUSE);
	END;
	
PROCEDURE MOUSE_GET;
	BEGIN
		REGS[XR]:=11;
		CALL(MS_GET);
		MB:=REGS[AR];				{MUST BE IMMEDIATELY AFTER MS_GET}
		MX:=PEEK(11)+PEEK(12)*256;
		MY:=PEEK(13);	
	END;
	
PROCEDURE GRAPHICS;					{turn on grahics mode}
    BEGIN
        REGS[0]:=0;
        CALL(GFX);
    END;	
	
PROCEDURE GETSTR(VAR S1: STRNG);
VAR L: CHAR;
	J,X,P: INTEGER;
	
	BEGIN
		J:=1;
		L:=' ';
		WHILE ORD(L) <> 13 DO BEGIN
			READ(L);
			{WRITE(L);}
			S1[J]:=L;
			WRITE(S1[J]);
			J:=J+1;
		END;	
		S1[0]:=CHR(J-1);	{LENGTH OF STRING}
	END;	
	
PROCEDURE PUTSTR(VAR S2: STRNG);
VAR X,N,P: INTEGER;

	BEGIN
	X:=1;
	N:=ORD(S2[0]);
	
	WHILE X < N DO BEGIN
		WRITE(S2[X]);
		X:=X+1;
	END;
END;
	
PROCEDURE INT2FLOAT(I,F:INTEGER);	{I IS INTEGER, F IS POINTER TO FLOAT}
	BEGIN
		REGS[1]:=I;	{INTEGER}
		REGS[2]:=F;	{POINTER TO FLOAT}
		SYS(IT2F);
	END;
	
PROCEDURE FLOAT2STRG(F: INTEGER);	{F IS POINTER TO FLOAT}
VAR X,Y: INTEGER;
	BEGIN
		FOR X:=0 TO 5 DO BEGIN		{COPY FLOAT TO FAC}
			Y:=PEEK(F+X);
			POKE($00C3+X,Y);
		END;
		REGS[0]:=FOUT;				{CONVERT TO STRING}
		FLOP();		
	END;
	
PROCEDURE FLOAT_DIV(R,D1,D2: INTEGER);
	BEGIN
		REGS[1]:=D2;
		REGS[2]:=D1;
		REGS[3]:=R;
		SYS(DIVF);
	END;
	
PROCEDURE FLOAT_ADD(R,D1,D2: INTEGER);
	BEGIN
		REGS[1]:=D2;
		REGS[2]:=D1;
		REGS[3]:=R;
		SYS(ADDF);
	END;	
	
PROCEDURE FLOAT_MUL(R,D1,D2: INTEGER);
	BEGIN
		REGS[1]:=D2;
		REGS[2]:=D1;
		REGS[3]:=R;
		SYS(MULF);
	END;	
	
PROCEDURE PRNT_FLOAT;	
	BEGIN
		REGS[0]:=$0100;
		SYS(PRSTRG);
	END;
	
{A BETTER WAY WOULD BE TO LOAD A .BIN FILE TO MEMORY DIRECTLY}
PROCEDURE FLT_LIB; {M/L ROUTINES TO PERFORM FP MATH FUNCTIONS}
	BEGIN
	READ(CODE[0],'160,1201,-15463,-20224,-26362,202,-16184');
	READ(CODE[7],'-12282,8433,-473,160,-15431,-28416,-14328');
	READ(CODE[14],'1728,-2352,96');		
	DIVF:=PTR(CODE[0]);		{DIVIDE}
	READ(CODE[17],'1445,-55,2032,1188,162,-32550,-24047');
	READ(CODE[24],'-9727,-183,6216,1189,-183,361,26792');
	READ(CODE[31],'105,800,-1282,1008,13088,-24322,-18176');
	READ(CODE[38],'195,1681,-16184,-12282,24822');
	IT2F:=PTR(CODE[17]);	{INTEGER TO FLOAT}
	READ(CODE[43],'160,1201,-15463,-20224,-26362,202,-16184');
	READ(CODE[50],'-12282,8433,-485,160,-15431,-28416,-14328');
	READ(CODE[57],'1728,-2352,96');
	ADDF:=PTR(CODE[43]);	{ADD}
	READ(CODE[60],'160,1201,-15463,-20224,-26362,202,-16184');
	READ(CODE[67],'-12282,8433,-479,160,-15431,-28416,-14328');
	READ(CODE[74],'1728,-2352,96');	
	MULF:=PTR(CODE[60]);	{MULTPLY}
	READ(CODE[77],'160,689,1776,-11744,-14081,-2432,96');{M/L TO PRINT A STRING}
	PRSTRG:=PTR(CODE[77]);	{STARTING ADDRESS OF ABOVE CODE}	
	READ(CODE[84],'160,1201,-15463,-20224,-26362,202,-16184');
	READ(CODE[91],'-12282,8433,-491,160,-15431,-28416,-14328');
	READ(CODE[98],'1728,-2352,96');	
	SUBF:=PTR(CODE[84]);
	READ(FPZERO[0],'0,0,0,0,0,0');
	READ(FPONE[0],'129,0,0,0,0,0');
	END;
				    
BEGIN
	{INITIALIZE FLOAT CODE}
	FLT_LIB;
	{ASSIGN PONTERS TO FLOAT VARIABLES}
	FP:=PTR(MYFLT[0])*2;
	FP2:=PTR(FLT2[0])*2; 
	FPR:=PTR(RES[0])*2;			
	WRITELN('THERE IS NO NATIVE SUPPORT FOR FLOATING POINT MATH IN');
	WRITELN('PASCAL-ISH...LETS DO SOME ANYWAY...');
	WRITELN;
	WRITE('ENTER A SIGNED INTEGER >= -32768 BUT <= 32767: ');
	READ(K);
	WRITE('AND A SECOND ONE: ');
	READ(J);
	INT2FLOAT(K,FP); 
	INT2FLOAT(J,FP2);	
	WRITELN;
	WRITE(K,' DIVIDED BY ',J,' IS ');
	FLOAT_DIV(FPR,FP,FP2);
	FLOAT2STRG(FPR);
	PRNT_FLOAT;
	WRITELN;
	WRITE('ADD ',J,' =');
	FLOAT_ADD(FPR,FPR,FP2);	
	FLOAT2STRG(FPR);
	PRNT_FLOAT;
	WRITELN;
	WRITE('MULTIPLIED BY ',K,' =');
	FLOAT_MUL(FPR,FPR,FP);
	FLOAT2STRG(FPR);
	PRNT_FLOAT;
	WRITELN;
	WRITE('DIVIDED BY ',J,' = ');
	FLOAT_DIV(FPR,FPR,FP2);	
	FLOAT2STRG(FPR);
	PRNT_FLOAT;	
	INT2FLOAT(J,FP2);	
	READ(CH);
	GOTOXY(0,12);	
	READ(CH);
	GRAPHICS;
	MOUSE_ON;
	GOTOXY(0,0);
	WRITELN('WHERE IS MY MOUSE? ');
	GOTOXY(0,10);
	WRITE('LEFT BUTTON CLICK TO END');
	MB:=0;
	REPEAT
		MOUSE_GET;
		GOTOXY(19,0);
		WRITE(MX,'  ',MY,'  ');
	UNTIL MB <> 0;
 END.
