PROGRAM FLOATTEST(INPUT,OUTPUT); 
USES(MATH);
CONST
    PC=10;
    AR=11;          {Accumulator = REGS[AR]}
    XR=12;          {X Register = REGS[XR]}
    YR=13;          {Y register = REGS[AY]}
    PETSCII=143;    {SWITCH TO PETSCII}
    ISO=15;         {SWITCH TO ISO TEXT}
    CLS=147;        {CLEAR TEXT SCREEN}
    GXY=$FFF0;      {Kernal PLOT}
    GFX=$FF20;      {Kernal GRAPH_INIT}
    GCS=$FF23;      {Kernal GRAPH_CLEAR}
    GCL=$FF29;      {Kernal GRAPH_SET_COLORS}
    RCT=$FF2F;      {Kernal GRAPH_DRAW_RECT}
    LIN=$FF2C;      {Kernal GRAPH_DRAW_LINE}
    SPX=$FF0B;      {Kernal FB_SET_PIXEL}
    PXY=$FEFF;      {Kernal FB_CURSOR_POS}
    SCR=$FF5F;      {KERNAL SCREEN MODE}
    STI=$FFDB;      {Kernal SETTIM}
    RTI=$FFDE;      {Kernal READTIM}
    PCR=$FF41;      {KERNAL GRAPH_PUT_CHAR}
    READST=$FFB7;   {KERNAL READ STATUS}
    OPEN=$FFC0;     {KERNAL OPEN}
    SETLFS=$FFBA;   {KERNAL SET LOGICAL FILE}
    SETNAM=$FFBD;   {KERNAL SET FILENAME}
    CHKIN=$FFC6;    {KERNAL CHKIN}
    CHRIN=$FFCF;    {KERNAL CHRIN}
    CHROUT=$FFD2;   {KERNAL CHROUT}
    CHKOUT=$FFC9;   {KERNAL CHKOUT}
    CLALL=$FFE7;    {KERNAL CLALL}
    MOUSE=$FF68;    {KERNAL MOUSE CONFIG}
    MS_GET=$FF6B;   {KERNAL MOUSE GET}
    SP_POS=$FEF3;   {KERNAL SPRITE SET POSITION}
    GIVAYF=$FE03;   {CONVERT SIGNED INTEGER TO FLOAT}
    MOVMF=$FE66;    {MOVE FLOAT FAC TO MEMORY}
    MOVFM=$FE63;    {MOVE FLOAT MEMORY TO FAC}
    CONUPK=$FE5A;   {MOVE FLOAT MEMORY TO FAC2(ARG)}
    FDIVT=$FE27;    {FAC = ARG/FAC}
    FOUT=$FE06;     {CONVERT FLOAT FAC TO STRING @ $0100}
    NEGOP=$FE33;    {FLIP SIGN OF VALUE IN FAC}
    VAL1=$FE09;     {CONVERT ASCII STRING TO FP}
    ABM=0;          {ABSOLUTE ADDRESSING}
    ZPX=1;          {ZERO PAGE X}
    ZPY=2;          {ZERO PAGE Y}
    INY=3;          {INDIRECT Y}
    INX=4;          {INDIRECT X}
    ABY=5;          {ABSOLUTE Y}
    ABX=6;          {ABSOLUTE X}
    IMM=7;          {IMMEDIATE}
    ZPP=8;          {ZERO PAGE}
    ACC=9;          {ACCUMULATOR}   
    IMP=10;         {IMPLIED}
    BRA=11;         {BRANCHES}
    BORDER=$9F2C;   {VERA Border Color}
TYPE STRNG = ARRAY [0..30] OF CHAR;
TYPE FLOAT = ARRAY [0..2] OF INTEGER;
VAR TI,MX,MY,MB,PRSTRG,SP,J,K,FP,FP2,FPR,Y,SEC,JIF,DIVF,IT2F,BPTR,FS: INTEGER;
C,ADDF,SUBF,MULF: INTEGER;
BUFF: ARRAY [0..20] OF INTEGER;
CODE: ARRAY [0..8] OF INTEGER;
FDIV,FADD,FSUB,FMUL: ARRAY [0..18] OF INTEGER;
ITOF: ARRAY [0..26] OF INTEGER;
CH,CH2,L: CHAR;
MYSTR,FPSTR: STRNG;
MYFLT,FLT2,RES: FLOAT;

PROCEDURE POKE(ADDR,VAL: INTEGER);
    BEGIN
        REGS[PC]:=1;        
        REGS[0]:=ADDR;
        REGS[AR]:=VAL;
        MEM();
    END;    
    
FUNCTION PEEK(ADDR: INTEGER): INTEGER;
    BEGIN
        REGS[PC]:=0;        
        REGS[0]:=ADDR;
        MEM();
        PEEK:=REGS[AR];
    END;    
    
PROCEDURE SCRNMODE(MODE:INTEGER);
    BEGIN
        REGS[AR]:=MODE;
        CALL(SCR);
    END;
    
PROCEDURE SETTIME(H,M,S:INTEGER);   {set software clock}
    BEGIN
        REGS[AR]:=H;REGS[XR]:=M;
        REGS[YR]:=S;
        CALL(STI);
    END;

FUNCTION READTIME: INTEGER;     {read software clock}
VAR T1:INTEGER;
    BEGIN
        CALL(RTI);
        T1:=(REGS[XR]*256) + REGS[AR];
        READTIME:= T1;     
    END;        
    
PROCEDURE GOTOXY(COL,ROW: INTEGER);
    BEGIN
        REGS[PC]:=0;
        REGS[YR]:=COL;
        REGS[XR]:=ROW;
        CALL(GXY);
    END;            
    
PROCEDURE PAUSE(JIFFIES: INTEGER);
    BEGIN
        REGS[AR]:=JIFFIES;
        WAIT();
    END;    
    
PROCEDURE MOUSE_ON;
    BEGIN
        REGS[AR]:=1;
        REGS[XR]:=320 DIV 8;
        REGS[YR]:=240 DIV 8;
        CALL(MOUSE);
    END;
    
PROCEDURE MOUSE_GET;
    BEGIN
        REGS[XR]:=11;
        CALL(MS_GET);
        MB:=REGS[AR];               {MUST BE IMMEDIATELY AFTER MS_GET}
        MX:=PEEK(11)+PEEK(12)*256;
        MY:=PEEK(13);   
    END;
    
PROCEDURE GRAPHICS;                 {turn on grahics mode}
    BEGIN
        REGS[0]:=0;
        CALL(GFX);
    END;    
    
PROCEDURE ASCII2FLT(L,F: INTEGER);  {A=POINTER TO STRING, F=POINTER TO FLOAT}
VAR X,C,N: INTEGER;
    BEGIN

        REGS[0]:=VAL1;              {CONVERSION ROUTINE}
        REGS[1]:=BPTR;              {POINTER TO STRING}
        REGS[AR]:=L;                {LENGTH OF STRING}
        {DBUG();}
        FLOP();                     {DO CONVERSION}
        FOR X:=0 TO 5 DO BEGIN      {COPY RESULT TO MEMORY}
            N:=PEEK($00C3+X);
            POKE(F+X,N);
        END;                
    END;
    
PROCEDURE INT2FLOAT(I,F:INTEGER);   {I IS INTEGER, F IS POINTER TO FLOAT}
    BEGIN
        REGS[1]:=I; {INTEGER}
        REGS[2]:=F; {POINTER TO FLOAT}
        SYS(IT2F);
    END;
    
PROCEDURE FLOAT2STRG(F: INTEGER);   {F IS POINTER TO FLOAT}
VAR X,Y: INTEGER;
    BEGIN
        FOR X:=0 TO 5 DO BEGIN      {COPY FLOAT TO FAC}
            Y:=PEEK(F+X);
            POKE($00C3+X,Y);
        END;
        REGS[0]:=FOUT;              {CONVERT TO STRING}
        FLOP();     
    END;
    
PROCEDURE FLOAT_DIV(R,D1,D2: INTEGER);
VAR X,N,I: INTEGER;
    BEGIN
        REGS[1]:=D2;
        REGS[2]:=D1;
        REGS[3]:=R;
        SYS(DIVF);
    END;
    
PROCEDURE FLOAT_ADD(R,D1,D2: INTEGER);
VAR X,N,I: INTEGER;
    BEGIN
        REGS[1]:=D2;
        REGS[2]:=D1;
        REGS[3]:=R;
        SYS(ADDF);
    END;    
    
PROCEDURE FLOAT_MUL(R,D1,D2: INTEGER);
VAR X,N,I: INTEGER;
    BEGIN
        REGS[1]:=D2;
        REGS[2]:=D1;
        REGS[3]:=R;
        SYS(MULF);
    END;    
    
PROCEDURE PRNT_FLOAT;   
VAR PF: INTEGER;
    BEGIN
        REGS[0]:=$0100;
        SYS(PRSTRG);
    END;

PROCEDURE GETSTR(VAR S1: STRNG);
VAR L: CHAR;
    J,X,P: INTEGER;
    
    BEGIN
        J:=1;
        L:=' ';
        WHILE ORD(L) <> 13 DO BEGIN
            READ(L);
            {WRITE(L);}
            S1[J]:=L;
            WRITE(S1[J]);
            J:=J+1;
        END;    
        S1[0]:=CHR(J-1);    {LENGTH OF STRING}
    END;    
    
PROCEDURE PUTSTR(VAR S2: STRNG);
VAR X,N,P: INTEGER;

    BEGIN
    X:=1;
    N:=ORD(S2[0]);
    
    WHILE X < N DO BEGIN
        WRITE(S2[X]);
        X:=X+1;
    END;
END;    
                    
BEGIN
    READ(CODE[0],'160,689,1776,-11744,-14081,-2432,96');{M/L TO PRINT A STRING}
    PRSTRG:=PTR(CODE[0]);   {STARTING ADDRESS OF ABOVE CODE}
    READ(FDIV[0],'160,1201,-15463,-20224,-26362,202,-16184');
    READ(FDIV[7],'-12282,8433,-473,160,-15431,-28416,-14328');
    READ(FDIV[14],'1728,-2352,96');{EXTRA ZERO NEEDED HERE, NOT 100% SURE WHY}
    DIVF:=PTR(FDIV[0]); 
    READ(ITOF[0],'1445,-55,2032,1188,162,-32550,-24047');
    READ(ITOF[7],'-9727,-183,6216,1189,-183,361,26792');
    READ(ITOF[14],'105,800,-1282,1008,13088,-24322,-18176');
    READ(ITOF[21],'195,1681,-16184,-12282,24822');
    IT2F:=PTR(ITOF[0]); 
    READ(FADD[0],'160,1201,-15463,-20224,-26362,202,-16184');
    READ(FADD[7],'-12282,8433,-485,160,-15431,-28416,-14328');
    READ(FADD[14],'1728,-2352,96');
    ADDF:=PTR(FADD[0]);
    READ(FMUL[0],'160,1201,-15463,-20224,-26362,202,-16184');
    READ(FMUL[7],'-12282,8433,-479,160,-15431,-28416,-14328');
    READ(FMUL[14],'1728,-2352,96'); 
    MULF:=PTR(FMUL[0]);
    BPTR:=PTR(BUFF[0])*2;
    WRITELN('TESTING FLOATING POINT LIBRARY');
    FP:=PTR(MYFLT[0])*2;
    FP2:=PTR(FLT2[0])*2; 
    FPR:=PTR(RES[0])*2;     {RESULT}    
    Y:=1;
    K:=-2049;
    J:=2;
    SETTIME(0,0,0); 
    INT2FLOAT(K,FP);        {-2049}
    INT2FLOAT(J,FP2);       {2} 
    REPEAT
        FLOAT_DIV(FPR,FP,FP2);  {-1024.5}
        FLOAT_ADD(FPR,FPR,FP2); {-1022.5}
        FLOAT_MUL(FPR,FPR,FP);  {2095102.5}
        FLOAT_DIV(FPR,FPR,FP2); {1047551.25}
        Y:=Y+1;
    UNTIL Y>238;
    FLOAT2STRG(FPR);
    TI:=READTIME;
    GOTOXY(0,5);
    WRITE('CALCULATED ((((-2049 / 2) + 2) * -2049)/ 2 ) = ');   
    PRNT_FLOAT;
    WRITELN(' 238 TIMES');
    GOTOXY(0,12);
    SEC:=TI DIV 60;
    JIF:=TI MOD 60; 
    Y:=Y-1; 
    WRITE(Y*4+5,' FLOATING POINT OPERATIONS IN ',SEC);
    WRITE(' Seconds ',JIF,' Jiffies');   
    READ(CH);
    GRAPHICS;
    MOUSE_ON;
    GOTOXY(0,0);
    WRITELN('WHERE IS MY MOUSE? ');
    GOTOXY(0,10);
    WRITE('LEFT BUTTON CLICK TO END');
    MB:=0;
    REPEAT
        MOUSE_GET;
        GOTOXY(19,0);
        WRITE(MX,'  ',MY,'  ');
    UNTIL MB <> 0;
 END.
