PROGRAM LIFE(INPUT,OUTPUT);
USES(AUDVID);
CONST
	DUMMY = 0;
	PC=10;			{RESERVED FOR CARRY FLAG IN REGS[]}
    AR=11;			{RESERVED FOR .A REGISTER IN REGS[]}
    XR=12;			{RESERVED FOR .X REGISTER IN REGS[]}
    YR=13;			{RESERVED FOR .Y REGISTER IN REGS[]}
	PETSCII=143;	{SWITCH TO PETSCII}
	ISO=15;			{SWITCH TO ISO TEXT}
	CLS=147;		{CLEAR TEXT SCREEN}
    PLT=-16;
    GFX=-224;
    GCS=-221;
    GCL=-215;
    CIR=-203;
    RCT=-209;
    LIN=-212;
    SPX=-245;
	SPS=-242;		{$FF0E KERNAL SET PIXELS}
    PXY=-257;
	SCR=-161;		{$FF5F KERNAL SCREEN MODE}
    STI=-37;
    RTI=-34;
	PCR=-191;		{$FF41 KERNAL GRAPH_PUT_CHAR}
	GXY=-16;    	{$fff0 kernal PLOT}	
	SCREEN=-20480;	{$B000 VRAM ADDRESS OF TEXT SCREEN}
	VCTRL=-24795;	{$9F25 VERA CONTROL PORT}
	VADDL=-24800;	{$9F20 VERA ADDRESS LO BYTE}
	VADDM=-24799;	{$9F21 VERA ADDRESS MID BYTE}
	VADDH=-24798;	{$9F22 VERA ADDRESS HI BYTE}
VAR ROW,NROW: ARRAY[0..51] OF BOOLEAN;
NCOUNT,WORLD: ARRAY[0..3328] OF INTEGER; { used to hold the neighbour counts }
CODE: ARRAY [0..29] OF INTEGER;
CODE2: ARRAY [0..56] OF INTEGER;
PCOUNT,CHGCNT,NC,L,A,TI,MIN,SEC,JIF,RS,G,WPTR,VAD,WP,CD,CDB: INTEGER;
COL,COLH,COLL,NCOLH,NCOLL: INTEGER;
CH: CHAR;

PROCEDURE VPOKE(BANK,ADDR,VAL: INTEGER);
	BEGIN
		REGS[PC]:=1;
		REGS[AR]:=BANK;
		REGS[0]:=ADDR;
		REGS[YR]:=VAL;
		VMEM();
	END;	
	
PROCEDURE POKE(ADDR,VAL: INTEGER);
	BEGIN
		REGS[PC]:=1;		
		REGS[0]:=ADDR;
		REGS[AR]:=VAL;
		MEM();
	END;
	
FUNCTION PEEK(ADDR: INTEGER):INTEGER;
	BEGIN
		REGS[PC]:=0;
		REGS[0]:=ADDR;
		MEM();
		PEEK:=REGS[AR];
	END;	
	
PROCEDURE VADDR(ADDR: INTEGER);	{SET THE VERA ADDRESS, BANK1 ONLY}
VAR BYTE: INTEGER;
	BEGIN
		POKE(VCTRL,0);
		BYTE:=ADDR MOD 256;
		POKE(VADDL,BYTE);
		BYTE:=ADDR DIV 256;
		POKE(VADDM,BYTE);
		BYTE:=17;				{BANK 1 FOR OUR PURPOSES}
		POKE(VADDH,BYTE);
	END;
	
PROCEDURE SETROW(ADDR: INTEGER);	{USE FB_SETPIXELS TO FILL TEXT ROW}
	BEGIN
		REGS[0]:=ADDR;
		REGS[1]:=128;
		CALL(SPS);
	END;
		
	
PROCEDURE SCRNMODE(MODE:INTEGER);
	BEGIN
		REGS[AR]:=MODE;
		CALL(SCR);
	END;	
	
PROCEDURE GOTOXY(COLUMN,ROW: INTEGER);
    BEGIN
        REGS[PC]:=0;
        REGS[XR]:=ROW;
        REGS[YR]:=COLUMN;
        CALL(PLT);
    END;	
	
PROCEDURE BELL;
	BEGIN
		CH:=CHR(7);		{PETSCII BELL SOUND}
		WRITE(CH);	
	END;
	
PROCEDURE SETTIME(H,M,S:INTEGER);	{set software clock}
    BEGIN
        REGS[AR]:=H;
		REGS[XR]:=M;
        REGS[YR]:=S;
        CALL(STI);
    END;
	
FUNCTION READTIME: INTEGER;		{read software clock}
VAR T1:INTEGER;
    BEGIN
        CALL(RTI);
		T1:=(REGS[XR]*256) + REGS[AR];
        READTIME:= T1;     
    END;	

PROCEDURE PRINTFO(I: INTEGER);
VAR C: CHAR;
K: INTEGER;
	BEGIN
		C:=CHR(5);
		WRITE(C);
		GOTOXY(4,2);
		WRITE('LOCATION=',I,' NCOUNT=',NCOUNT[I]);
		READ(K);
	END;

PROCEDURE SETUP;
VAR C: INTEGER;
	BEGIN
		C:=0;
		WHILE C <= 3328 DO BEGIN
			WORLD[C]:=81;
			C:=C+1;
		END;	
		C:=0;
		WHILE C < 52 DO BEGIN
			ROW[C]:=FALSE;
			C:=C+1;
		END;
		C:=21*64+30;		{Thunderbird}
		WORLD[C]:=1873;		
		ROW[20]:=TRUE;
		ROW[21]:=TRUE;
		ROW[22]:=TRUE;
		C:=21*64+31;
		WORLD[C]:=1873;		
		C:=21*64+32;	
		WORLD[C]:=1873;		
		C:=23*64+31;	
		WORLD[C]:=1873;			
		ROW[23]:=TRUE;
		ROW[24]:=TRUE;		
		C:=24*64+31;	
		WORLD[C]:=1873;			
		ROW[25]:=TRUE;		
		C:=25*64+31;					
		WORLD[C]:=1873;			
		ROW[26]:=TRUE;
		C:=0;
		WHILE C < 52 DO BEGIN	{set new list of rows to check,to original}
			NROW[C]:=ROW[C];
			C:=C+1;
		END;
		G:=0;		
	END;

PROCEDURE UFLSE(L: INTEGER);
BEGIN
	WORLD[L]:=81;		{$0051 WHICH WILL BE $51 00}
END;

PROCEDURE UTRU(L: INTEGER);
VAR R,C: INTEGER;
BEGIN
	WORLD[L]:=1873;		{$0751 WHICH WILL BE $51 $07}
	R:=L DIV 64;
	NROW[R]:=TRUE;
	NROW[R+1]:=TRUE;
	NROW[R-1]:=TRUE;		
END;   

FUNCTION COUNT(LOC: INTEGER): INTEGER;
  VAR CNT,P2,LB,HB: INTEGER;
  BEGIN
	P2:=WPTR+(LOC*2);	{CURRENT LOCATION WITHIN WORLD[]}
	LB:=P2 MOD 256;
	HB:=P2 DIV 256;
	POKE(CDB*2+4,LB);	{SET THESE VALUES IN THE CODE}
	POKE(CDB*2+10,HB);
	SYS(CDB);			{DO THE COUNT)}
	COUNT:=CNT;
END;

PROCEDURE DISPLAY;
VAR C,LB,HB:INTEGER;
	BEGIN
		VADDR(SCREEN+256);		{POINT VERA TO TEXT SCREEN}
		LB:=WPTR MOD 256;
		HB:=WPTR DIV 256;
		POKE(4,LB);			{#$2C IN $04}
		POKE(5,HB);			{#$4B IN $05}
		SYS(CD);
		C:=0;
		WHILE C < 51 DO BEGIN	{update list of rows to check from new list}
			ROW[C]:=NROW[C];
			C:=C+1;
			NROW[C-1]:=FALSE;
		END;
END;

PROCEDURE UPDATE;
  VAR C,C1,L,R,E: INTEGER;
  TF: BOOLEAN;
	BEGIN
		R:=1;
		WHILE R <= 51 DO BEGIN
			IF ROW[R] = TRUE THEN BEGIN
				C:= R*64+COLL;
				C1:=C+COLH;
				{WHILE C <= C1 DO BEGIN}
				REPEAT
					NCOUNT[C]:=COUNT(C);
					C:=C+1;
				UNTIL C = C1;
				{END;}
			END;
			R:=R+1;
		END;
		R:=1;
		REPEAT
			IF ROW[R] = TRUE THEN BEGIN
				C:=R*64+COLL;
				C1:=C+COLH;
				WHILE C <= C1 DO BEGIN
					IF WORLD[C] = 1873 THEN BEGIN
						IF NCOUNT[C] <= 1 THEN WORLD[C]:=81 ELSE
							IF NCOUNT[C] = 2 THEN UTRU(C) ELSE
								IF NCOUNT[C] = 3 THEN UTRU(C) ELSE WORLD[C]:=81;
					END
					ELSE BEGIN
						IF WORLD[C] = 81 THEN BEGIN
							IF NCOUNT[C] = 3 THEN UTRU(C) ELSE WORLD[C]:=81;
						END;
					END;
					C:=C+1;
				END;
			END;
			R:=R+1;
		UNTIL R = 52;
	END;

	BEGIN
		{MACHINE CODE TO UPDATE THE SCREEN}
		READ(CODE[0],'162,1189,-33659,1445,-33403,160,-33615,9101,-14177');
		READ(CODE[9],'-32576,-2352,-23272,26884,-31360,-23292,-38651,-31488,6149');
		READ(CODE[18],'8365,27039,-29312,-24800,8621,27039,-29440,-24799');
		READ(CODE[26],'-7960,-12238,24777');
		{MACHINE CODE TO COUNT A 'LIVE' CELL'S NEIGHBORS}
		READ(CODE2[0],'162,-22216,-5844,-31359,-22270,-5813,-31488,8195,19123');
		READ(CODE2[9],'-17632,8266,19131,-13280,8266,19165,-13280,8266,19131');
		READ(CODE2[18],'-17632,-22198,-31430,-22268,-31414,-24571,-30208,1169');
		READ(CODE2[26],'-24480,-20224,-4094,-6143,6240,677,617,645,933,105,901');
		READ(CODE2[37],'-19680,24650,-23272,26882,-31360,-23294,26883,-31488,8195');
		READ(CODE2[46],'19123,14432,677,1257,645,933,233,901,-19680,24650');
		CD:=PTR(CODE[0]);	{POINTER TO START ADDRESS OF SCREEN UPDATE}
		CDB:=PTR(CODE2[0]);	{POINTER TO START ADDRESS OF COUNT NEIGHBORS}
		WPTR:=PTR(WORLD[0])*2;	{POINTER TO WORLD ARRAY}
		L:=0;
		SCRNMODE(8);		
		CH:=CHR(PETSCII);
		WRITE(CH);
		{CH:=CHR(144);			{TEXT COLOR BLACK}	
		WRITE(CH);		
		CH:=CHR(CLS);			{CLEAR TEXT SCREEN}
		WRITE(CH);		
		A:=0;	
		SETUP;
		COLL:=3;
		COLH:=59;
		CH:=CHR(5);
		WHILE L = 0 DO BEGIN	
			DISPLAY;
			UPDATE;
			G:=G+1;
			GOTOXY(0,0);
			WRITE(CH,'T:',G);
			IF G = 248 THEN BEGIN
				GOTOXY(6,0);			
				WRITE(CH,'GENERATIONS COMPLETE');	
				READ(G);
			END;
		END;
END.